Draft Proxy de plan de travail

From FreeCAD Documentation
Revision as of 14:46, 10 February 2019 by FuzzyBot (talk | contribs) (Updating to match new version of source page)

Draft SetWorkingPlaneProxy

Emplacement du menu
Draft → Utilitaires → Créer WP Proxy
Ateliers
Draft, Arch
Raccourci par défaut
Aucun
Introduit dans la version
-
Voir aussi
Draft SelectPlane

Description

Cette commande placera un objet Proxy dans le document, placé et aligné sur le Working Plane actuel. Lorsque vous utilisez la commande Draft SelectPlane avec un tel objet Proxy sélectionné ou en double-cliquant dessus dans l'arborescence, le plan de travail sera positionné et aligné avec l'objet proxy. La position de la caméra et l'état masqué/affiché des objets sont également stockés dans l'objet Proxy et peuvent être restaurés si les propriétés correspondantes sont activées (voir ci-dessous).

This proxy object can be used like a face to quickly change the working plane using the Draft SelectPlane tool. The camera position and visibility of the objects in the 3D view can be saved in the proxy object, and restored at anytime when the Draft SelectPlane tool is used.

Three working plane proxies showing different orientations and offsets

Comment l'utiliser

  1. Make sure the Plan de travail is set as you want.
  2. Cliquez Draft -> Utilitaires -> File:Draft SetWorkingPlaneProxy.png Créer un PT Proxy

Notes:

  • The working plane stored in the Proxy object can be restored by double-clicking the object in the tree view, or by selecting the Proxy object and using the Draft SelectPlane button.
  • The position of the camera is stored in the Proxy object upon creation. This position can be updated anytime: zoom, pan and rotate the view as you wish, then right-click the Proxy object in the tree view, and select Write camera position.
  • The visibility state of all objects is also stored in the Proxy object upon creation. This state can be updated anytime: set the VueVisibility property of the objects to true or false as desired, then right-click the Proxy object in the tree view, and select Write objects state.
  • Plane proxies can be moved and rotated like any other object so that they define the desired working plane. Their visual appearance can also be changed in the property editor.

Propriétés

  • DonnéesPlacement: Stocke la position de ce Proxy et du plan de travail correspondant
  • VueDisplay Size: La dimension de l'objet Proxy dans la vue 3D
  • VueArrow Size: La dimension des flèches dans les 3 axes
  • VueRestore View: Si True, la position de la caméra est restaurée ou activée (ou double-cliquez sur l'objet Draft SelectPlane)
  • VueRestore State: Si True, la visibilité de tous les objets dans documents est restaurée ou activée (ou double-cliquez sur l'objet Draft SelectPlane)

View

  • VueDisplay Size: specifies both length and width of the proxy object. If the object is created in the tree view but no element is visible in the 3D view, increase this value until it is visible.
  • VueArrow Size: specifies the size of the arrows indicating the three axes of the plane proxy.
  • VueRestore View: if it is true the camera position will be restored to the saved position when using the proxy with Draft SelectPlane or by double-clicking on it.
  • VueRestore State: if it is true the visibility state of all objects will be restored to the saved state when using the proxy with Draft SelectPlane or by double-clicking on it.

Scripting

L'objet Working plane proxy peut être facilement créé avec une macros en utilisant le script ci dessous:

See also: Draft API and FreeCAD Scripting Basics.

Working plane proxy objects can be used in macros and from the Python console by using the following function:

WPProxy = makeWorkingPlaneProxy(placement)
  • Creates a WPProxy object from the given placement which is a FreeCAD.Placement.
    • A placement is defined by a base point, given by its FreeCAD.Vector, and a FreeCAD.Rotation.

The size of the Plane Proxy can be changed by overwriting its ViewObject.DisplaySize and ViewObject.ArrowSize attributes, with units in millimeters.

The Plane Proxy has a "Face" object as its Shape attribute. This face can be used to set the current working plane by calling its alignToFace() method.

Exemple:

import FreeCAD, FreeCADGui, Draft

currentWP = FreeCAD.DraftWorkingPlane
place = currentWP.getPlacement()

WPProxy = Draft.makeWorkingPlaneProxy(place)
WPProxy.ViewObject.DisplaySize = 3000
WPProxy.ViewObject.ArrowSize = 200

YAxis = FreeCAD.Vector(0, 1, 0)
point2 = FreeCAD.Vector(3000, 0, 0)
place2 = FreeCAD.Placement(point2, FreeCAD.Rotation(YAxis, 90))

WPProxy2 = Draft.makeWorkingPlaneProxy(place2)
WPProxy2.ViewObject.DisplaySize = 3000
WPProxy2.ViewObject.ArrowSize = 200

Axis = FreeCAD.Vector(1, 1, 1)
point3 = FreeCAD.Vector(-3000, 3000, 0)
place3 = FreeCAD.Placement(point3, FreeCAD.Rotation(Axis, 90))

WPProxy3 = Draft.makeWorkingPlaneProxy(place3)
WPProxy3.ViewObject.DisplaySize = 3000
WPProxy3.ViewObject.ArrowSize = 200
FreeCAD.ActiveDocument.recompute()

currentWP.alignToFace(WPProxy3.Shape)
FreeCADGui.Snapper.setGrid()